#include <zombie_escape>

#define CHECK_STUCK_TASKID 2018

new const Float:fSize[][3] =
{
	{0.0, 0.0, 1.0}, {0.0, 0.0, -1.0}, {0.0, 1.0, 0.0}, {0.0, -1.0, 0.0}, {1.0, 0.0, 0.0}, {-1.0, 0.0, 0.0}, {-1.0, 1.0, 1.0}, {1.0, 1.0, 1.0}, {1.0, -1.0, 1.0}, {1.0, 1.0, -1.0}, {-1.0, -1.0, 1.0}, {1.0, -1.0, -1.0}, {-1.0, 1.0, -1.0}, {-1.0, -1.0, -1.0},
	{0.0, 0.0, 2.0}, {0.0, 0.0, -2.0}, {0.0, 2.0, 0.0}, {0.0, -2.0, 0.0}, {2.0, 0.0, 0.0}, {-2.0, 0.0, 0.0}, {-2.0, 2.0, 2.0}, {2.0, 2.0, 2.0}, {2.0, -2.0, 2.0}, {2.0, 2.0, -2.0}, {-2.0, -2.0, 2.0}, {2.0, -2.0, -2.0}, {-2.0, 2.0, -2.0}, {-2.0, -2.0, -2.0},
	{0.0, 0.0, 3.0}, {0.0, 0.0, -3.0}, {0.0, 3.0, 0.0}, {0.0, -3.0, 0.0}, {3.0, 0.0, 0.0}, {-3.0, 0.0, 0.0}, {-3.0, 3.0, 3.0}, {3.0, 3.0, 3.0}, {3.0, -3.0, 3.0}, {3.0, 3.0, -3.0}, {-3.0, -3.0, 3.0}, {3.0, -3.0, -3.0}, {-3.0, 3.0, -3.0}, {-3.0, -3.0, -3.0},
	{0.0, 0.0, 4.0}, {0.0, 0.0, -4.0}, {0.0, 4.0, 0.0}, {0.0, -4.0, 0.0}, {4.0, 0.0, 0.0}, {-4.0, 0.0, 0.0}, {-4.0, 4.0, 4.0}, {4.0, 4.0, 4.0}, {4.0, -4.0, 4.0}, {4.0, 4.0, -4.0}, {-4.0, -4.0, 4.0}, {4.0, -4.0, -4.0}, {-4.0, 4.0, -4.0}, {-4.0, -4.0, -4.0},
	{0.0, 0.0, 5.0}, {0.0, 0.0, -5.0}, {0.0, 5.0, 0.0}, {0.0, -5.0, 0.0}, {5.0, 0.0, 0.0}, {-5.0, 0.0, 0.0}, {-5.0, 5.0, 5.0}, {5.0, 5.0, 5.0}, {5.0, -5.0, 5.0}, {5.0, 5.0, -5.0}, {-5.0, -5.0, 5.0}, {5.0, -5.0, -5.0}, {-5.0, 5.0, -5.0}, {-5.0, -5.0, -5.0}
}

new Float:g_fSpawned[33], bool:g_bFixSpawn, bool:g_bZombieAppear
new pCvarHumanHP, pCvarZombieHP

public plugin_natives()
{
	register_native("ze_unstuck_player", "native_ze_unstuck_player", 1)
}

public plugin_init()
{
	register_plugin("[ZE] Bad Spawn Fix", "1.0","Raheem")
	
	RegisterHookChain(RG_CBasePlayer_Spawn, "Fw_PlayerSpawn_Post", 1)
	RegisterHookChain(RG_CBasePlayer_Killed, "Fw_PlayerKilled_Post", 1)
	
	pCvarHumanHP = get_cvar_pointer("ze_human_health")
	pCvarZombieHP = get_cvar_pointer("ze_first_zombies_health")
}

public ze_game_started()
{
	g_bFixSpawn = true
	g_bZombieAppear = false
	
	set_task(0.1, "CheckStuck", CHECK_STUCK_TASKID, _, _, "b")
}

public ze_zombie_release()
{
	g_bFixSpawn = false
	remove_task(CHECK_STUCK_TASKID)
}

public ze_zombie_appear()
{
	g_bZombieAppear = true
}

public Fw_PlayerSpawn_Post(id)
{
	if (g_bFixSpawn)
	{
		if (is_user_alive(id))
		{
			g_fSpawned[id] = get_gametime()
		}
	}
}

public Fw_PlayerKilled_Post(id)
{
	if (g_bFixSpawn)
	{
		if((get_gametime() - g_fSpawned[id]) < 0.02)
		{
			set_task(0.1, "ReSpawn", id)
		}
	}
}

public ReSpawn(id)
{
	rg_round_respawn(id)
}

public CheckStuck()
{
	if (g_bFixSpawn)
	{
		new Float:fNewOrigin[3], Float:fMins[3], Float:fOrigin[3]
	
		for (new id = 1; id <= get_member_game(m_nMaxPlayers); id++)
		{
			if (!is_user_alive(id))
				continue
		
			if (is_user_stuck(id))
			{
				get_entvar(id, var_origin, fOrigin)
				get_entvar(id, var_mins, fMins)
			
				for (new i = 0; i < charsmax(fSize); i++)
				{
					if (!is_user_stuck(id) || (g_bZombieAppear && !ze_is_user_zombie(id)))
						break;
				
					fNewOrigin[0] = fOrigin[0] - fMins[0] * fSize[i][0]
					fNewOrigin[1] = fOrigin[1] - fMins[1] * fSize[i][1]
					fNewOrigin[2] = fOrigin[2] - fMins[2] * fSize[i][2]
				
					engfunc(EngFunc_SetOrigin, id, fNewOrigin)
					
					if (ze_is_user_zombie(id))
					{
						set_entvar(id, var_health, get_pcvar_float(pCvarZombieHP))
					}
					else
					{
						set_entvar(id, var_health, get_pcvar_float(pCvarHumanHP))
					}

					client_cmd(id,"spk fvox/blip.wav")
				}
			}
		}
	}
}

public native_ze_unstuck_player(id)
{
	if (!g_bFixSpawn)
	{
		if (!is_user_alive(id))
			return
		
		new Float:fNewOrigin[3], Float:fMins[3], Float:fOrigin[3], bool:bFoundFree = false, iHull
		
		get_entvar(id, var_origin, fOrigin)
		get_entvar(id, var_mins, fMins)
		
		for (new i = 0; i < charsmax(fSize); i++)
		{
			if (!is_user_alive(id) || bFoundFree)
				break;
			
			fNewOrigin[0] = fOrigin[0] - fMins[0] * fSize[i][0]
			fNewOrigin[1] = fOrigin[1] - fMins[1] * fSize[i][1]
			fNewOrigin[2] = fOrigin[2] - fMins[2] * fSize[i][2]
			
			iHull = (get_entvar(id, var_flags) & FL_DUCKING) ? HULL_HEAD : HULL_HUMAN
			engfunc (EngFunc_TraceHull, fNewOrigin, fNewOrigin, 0, iHull, id, 0)
			
			if (get_tr2(0, TR_InOpen) && !get_tr2(0, TR_AllSolid) && !get_tr2(0, TR_StartSolid))
			{
				engfunc(EngFunc_SetOrigin, id, fNewOrigin)
				client_cmd(id,"spk fvox/blip.wav")
				ze_colored_print(id, "!tYou have moved to new origin!y!")
				
				if (!is_user_stuck(id))
					bFoundFree = true
			}
		}
	}
	else if (g_bFixSpawn)
	{
		ze_colored_print(id, "!tAutomatic Unstuck is !gON!y, !tYou can't use it right now!y!")
	}
}

stock is_user_stuck(id)
{
	new Float:fOrigin[3], iHull

	get_entvar(id, var_origin, fOrigin)
	iHull = (get_entvar(id, var_flags) & FL_DUCKING) ? HULL_HEAD : HULL_HUMAN

	engfunc(EngFunc_TraceHull, fOrigin, fOrigin, 0, iHull, id, 0) 
	
	if (get_tr2(0, TR_StartSolid) || get_tr2(0, TR_AllSolid) || !get_tr2(0, TR_InOpen))
		return true

	return false
}